##// END OF EJS Templates
Added: Initial QEMU emulation support
drtyhlpr -
r259:a940fc511d48
parent child
Show More
@@ -1,230 +1,236
1 1 #
2 2 # Build and Setup RPi2/3 Kernel
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 # Fetch and build latest raspberry kernel
9 9 if [ "$BUILD_KERNEL" = true ] ; then
10 10 # Setup source directory
11 11 mkdir -p "${R}/usr/src/linux"
12 12
13 13 # Copy existing kernel sources into chroot directory
14 14 if [ -n "$KERNELSRC_DIR" ] && [ -d "$KERNELSRC_DIR" ] ; then
15 15 # Copy kernel sources and include hidden files
16 16 cp -r "${KERNELSRC_DIR}/". "${R}/usr/src/linux"
17 17
18 18 # Clean the kernel sources
19 19 if [ "$KERNELSRC_CLEAN" = true ] && [ "$KERNELSRC_PREBUILT" = false ] ; then
20 20 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" mrproper
21 21 fi
22 22 else # KERNELSRC_DIR=""
23 23 # Create temporary directory for kernel sources
24 24 temp_dir=$(as_nobody mktemp -d)
25 25
26 26 # Fetch current RPi2/3 kernel sources
27 27 if [ -z "${KERNEL_BRANCH}" ] ; then
28 28 as_nobody -H git -C "${temp_dir}" clone --depth=1 "${KERNEL_URL}" linux
29 29 else
30 30 as_nobody -H git -C "${temp_dir}" clone --depth=1 --branch "${KERNEL_BRANCH}" "${KERNEL_URL}" linux
31 31 fi
32 32
33 33 # Copy downloaded kernel sources
34 34 cp -r "${temp_dir}/linux/"* "${R}/usr/src/linux/"
35 35
36 36 # Remove temporary directory for kernel sources
37 37 rm -fr "${temp_dir}"
38 38
39 39 # Set permissions of the kernel sources
40 40 chown -R root:root "${R}/usr/src"
41 41 fi
42 42
43 43 # Calculate optimal number of kernel building threads
44 44 if [ "$KERNEL_THREADS" = "1" ] && [ -r /proc/cpuinfo ] ; then
45 45 KERNEL_THREADS=$(grep -c processor /proc/cpuinfo)
46 46 fi
47 47
48 48 # Configure and build kernel
49 49 if [ "$KERNELSRC_PREBUILT" = false ] ; then
50 50 # Remove device, network and filesystem drivers from kernel configuration
51 51 if [ "$KERNEL_REDUCE" = true ] ; then
52 52 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" "${KERNEL_DEFCONFIG}"
53 53 sed -i\
54 54 -e "s/\(^CONFIG_SND.*\=\).*/\1n/"\
55 55 -e "s/\(^CONFIG_SOUND.*\=\).*/\1n/"\
56 56 -e "s/\(^CONFIG_AC97.*\=\).*/\1n/"\
57 57 -e "s/\(^CONFIG_VIDEO_.*\=\).*/\1n/"\
58 58 -e "s/\(^CONFIG_MEDIA_TUNER.*\=\).*/\1n/"\
59 59 -e "s/\(^CONFIG_DVB.*\=\)[ym]/\1n/"\
60 60 -e "s/\(^CONFIG_REISERFS.*\=\).*/\1n/"\
61 61 -e "s/\(^CONFIG_JFS.*\=\).*/\1n/"\
62 62 -e "s/\(^CONFIG_XFS.*\=\).*/\1n/"\
63 63 -e "s/\(^CONFIG_GFS2.*\=\).*/\1n/"\
64 64 -e "s/\(^CONFIG_OCFS2.*\=\).*/\1n/"\
65 65 -e "s/\(^CONFIG_BTRFS.*\=\).*/\1n/"\
66 66 -e "s/\(^CONFIG_HFS.*\=\).*/\1n/"\
67 67 -e "s/\(^CONFIG_JFFS2.*\=\)[ym]/\1n/"\
68 68 -e "s/\(^CONFIG_UBIFS.*\=\).*/\1n/"\
69 69 -e "s/\(^CONFIG_SQUASHFS.*\=\)[ym]/\1n/"\
70 70 -e "s/\(^CONFIG_W1.*\=\)[ym]/\1n/"\
71 71 -e "s/\(^CONFIG_HAMRADIO.*\=\).*/\1n/"\
72 72 -e "s/\(^CONFIG_CAN.*\=\).*/\1n/"\
73 73 -e "s/\(^CONFIG_IRDA.*\=\).*/\1n/"\
74 74 -e "s/\(^CONFIG_BT_.*\=\).*/\1n/"\
75 75 -e "s/\(^CONFIG_WIMAX.*\=\)[ym]/\1n/"\
76 76 -e "s/\(^CONFIG_6LOWPAN.*\=\).*/\1n/"\
77 77 -e "s/\(^CONFIG_IEEE802154.*\=\).*/\1n/"\
78 78 -e "s/\(^CONFIG_NFC.*\=\).*/\1n/"\
79 79 -e "s/\(^CONFIG_FB_TFT=.*\=\).*/\1n/"\
80 80 -e "s/\(^CONFIG_TOUCHSCREEN.*\=\).*/\1n/"\
81 81 -e "s/\(^CONFIG_USB_GSPCA_.*\=\).*/\1n/"\
82 82 -e "s/\(^CONFIG_DRM.*\=\).*/\1n/"\
83 83 "${KERNEL_DIR}/.config"
84 84 fi
85 85
86 86 if [ "$KERNELSRC_CONFIG" = true ] ; then
87 87 # Load default raspberry kernel configuration
88 88 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" "${KERNEL_DEFCONFIG}"
89 89
90 # Set kernel configuration parameters to enable qemu emulation
91 if [ "$ENABLE_QEMU" = true ] ; then
92 echo "CONFIG_FHANDLE=y" >> ${KERNEL_DIR}/.config
93 echo "CONFIG_LBDAF=y" >> ${KERNEL_DIR}/.config
94 fi
95
90 96 # Copy custom kernel configuration file
91 97 if [ ! -z "$KERNELSRC_USRCONFIG" ] ; then
92 98 cp $KERNELSRC_USRCONFIG ${KERNEL_DIR}/.config
93 99 fi
94 100
95 101 # Set kernel configuration parameters to their default values
96 102 if [ "$KERNEL_OLDDEFCONFIG" = true ] ; then
97 103 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" olddefconfig
98 104 fi
99 105
100 106 # Start menu-driven kernel configuration (interactive)
101 107 if [ "$KERNEL_MENUCONFIG" = true ] ; then
102 108 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" menuconfig
103 109 fi
104 110 fi
105 111
106 112 # Use ccache to cross compile the kernel
107 113 if [ "$KERNEL_CCACHE" = true ] ; then
108 114 cc="ccache ${CROSS_COMPILE}gcc"
109 115 else
110 116 cc="${CROSS_COMPILE}gcc"
111 117 fi
112 118
113 119 # Cross compile kernel and dtbs
114 120 make -C "${KERNEL_DIR}" -j${KERNEL_THREADS} ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" CC="${cc}" "${KERNEL_BIN_IMAGE}" dtbs
115 121
116 122 # Cross compile kernel modules
117 123 if [ $(grep "CONFIG_MODULES=y" "${KERNEL_DIR}/.config") ] ; then
118 124 make -C "${KERNEL_DIR}" -j${KERNEL_THREADS} ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" CC="${cc}" modules
119 125 fi
120 126 fi
121 127
122 128 # Check if kernel compilation was successful
123 129 if [ ! -r "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/${KERNEL_BIN_IMAGE}" ] ; then
124 130 echo "error: kernel compilation failed! (kernel image not found)"
125 131 cleanup
126 132 exit 1
127 133 fi
128 134
129 135 # Install kernel modules
130 136 if [ "$ENABLE_REDUCE" = true ] ; then
131 137 if [ $(grep "CONFIG_MODULES=y" "${KERNEL_DIR}/.config") ] ; then
132 138 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" INSTALL_MOD_STRIP=1 INSTALL_MOD_PATH=../../.. modules_install
133 139 fi
134 140 else
135 141 if [ $(grep "CONFIG_MODULES=y" "${KERNEL_DIR}/.config") ] ; then
136 142 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" INSTALL_MOD_PATH=../../.. modules_install
137 143 fi
138 144
139 145 # Install kernel firmware
140 146 if [ $(grep "^firmware_install:" "${KERNEL_DIR}/Makefile") ] ; then
141 147 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" INSTALL_FW_PATH=../../../lib firmware_install
142 148 fi
143 149 fi
144 150
145 151 # Install kernel headers
146 152 if [ "$KERNEL_HEADERS" = true ] && [ "$KERNEL_REDUCE" = false ] ; then
147 153 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" INSTALL_HDR_PATH=../.. headers_install
148 154 fi
149 155
150 156 # Prepare boot (firmware) directory
151 157 mkdir "${BOOT_DIR}"
152 158
153 159 # Get kernel release version
154 160 KERNEL_VERSION=`cat "${KERNEL_DIR}/include/config/kernel.release"`
155 161
156 162 # Copy kernel configuration file to the boot directory
157 163 install_readonly "${KERNEL_DIR}/.config" "${R}/boot/config-${KERNEL_VERSION}"
158 164
159 165 # Prepare device tree directory
160 166 mkdir "${BOOT_DIR}/overlays"
161 167
162 168 # Ensure the proper .dtb is located
163 169 if [ "$KERNEL_ARCH" = "arm" ] ; then
164 170 for dtb in "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/"*.dtb ; do
165 171 if [ -f "${dtb}" ] ; then
166 172 install_readonly "${dtb}" "${BOOT_DIR}/"
167 173 fi
168 174 done
169 175 else
170 176 for dtb in "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/broadcom/"*.dtb ; do
171 177 if [ -f "${dtb}" ] ; then
172 178 install_readonly "${dtb}" "${BOOT_DIR}/"
173 179 fi
174 180 done
175 181 fi
176 182
177 183 # Copy compiled dtb device tree files
178 184 if [ -d "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/overlays" ] ; then
179 185 for dtb in "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/overlays/"*.dtb ; do
180 186 if [ -f "${dtb}" ] ; then
181 187 install_readonly "${dtb}" "${BOOT_DIR}/overlays/"
182 188 fi
183 189 done
184 190
185 191 if [ -f "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/overlays/README" ] ; then
186 192 install_readonly "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/overlays/README" "${BOOT_DIR}/overlays/README"
187 193 fi
188 194 fi
189 195
190 196 if [ "$ENABLE_UBOOT" = false ] ; then
191 197 # Convert and copy kernel image to the boot directory
192 198 "${KERNEL_DIR}/scripts/mkknlimg" "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/${KERNEL_BIN_IMAGE}" "${BOOT_DIR}/${KERNEL_IMAGE}"
193 199 else
194 200 # Copy kernel image to the boot directory
195 201 install_readonly "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/${KERNEL_BIN_IMAGE}" "${BOOT_DIR}/${KERNEL_IMAGE}"
196 202 fi
197 203
198 204 # Remove kernel sources
199 205 if [ "$KERNEL_REMOVESRC" = true ] ; then
200 206 rm -fr "${KERNEL_DIR}"
201 207 else
202 208 # Prepare compiled kernel modules
203 209 if [ $(grep "CONFIG_MODULES=y" "${KERNEL_DIR}/.config") ] ; then
204 210 if [ $(grep "^modules_prepare:" "${KERNEL_DIR}/Makefile") ] ; then
205 211 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" modules_prepare
206 212 fi
207 213
208 214 # Create symlinks for kernel modules
209 215 chroot_exec ln -sf /usr/src/linux "/lib/modules/${KERNEL_VERSION}/build"
210 216 chroot_exec ln -sf /usr/src/linux "/lib/modules/${KERNEL_VERSION}/source"
211 217 fi
212 218 fi
213 219
214 220 else # BUILD_KERNEL=false
215 221 # Kernel installation
216 222 chroot_exec apt-get -qq -y --no-install-recommends install linux-image-"${COLLABORA_KERNEL}" raspberrypi-bootloader-nokernel
217 223
218 224 # Install flash-kernel last so it doesn't try (and fail) to detect the platform in the chroot
219 225 chroot_exec apt-get -qq -y install flash-kernel
220 226
221 227 # Check if kernel installation was successful
222 228 VMLINUZ="$(ls -1 ${R}/boot/vmlinuz-* | sort | tail -n 1)"
223 229 if [ -z "$VMLINUZ" ] ; then
224 230 echo "error: kernel installation failed! (/boot/vmlinuz-* not found)"
225 231 cleanup
226 232 exit 1
227 233 fi
228 234 # Copy vmlinuz kernel to the boot directory
229 235 install_readonly "${VMLINUZ}" "${BOOT_DIR}/${KERNEL_IMAGE}"
230 236 fi
@@ -1,693 +1,741
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 20+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45 #bcm2708-rpi-0-w.dtb (Used for Pi 0 and PI 0W)
46 46 RPI0_DTB_FILE=${RPI0_DTB_FILE:=bcm2708-rpi-0-w.dtb}
47 47 RPI0_UBOOT_CONFIG=${RPI0_UBOOT_CONFIG:=rpi_defconfig}
48 48 #bcm2708-rpi-b.dtb (Used for Pi 1 model A and B)
49 49 RPI1_DTB_FILE=${RPI1_DTB_FILE:=bcm2708-rpi-b.dtb}
50 50 RPI1_UBOOT_CONFIG=${RPI1_UBOOT_CONFIG:=rpi_defconfig}
51 51 #bcm2708-rpi-b-plus.dtb (Used for Pi 1 model B+ and A+)
52 52 RPI1P_DTB_FILE=${RPI1P_DTB_FILE:=bcm2708-rpi-b-plus.dtb}
53 53 RPI1P_UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG:=rpi_defconfig}
54 54 #bcm2709-rpi-2-b.dtb (Used for Pi 2 model B)
55 55 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
56 56 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
57 57 #bcm2710-rpi-3-b.dtb (Used for Pi 3 model B)
58 58 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
59 59 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
60 60 #bcm2710-rpi-3-b-plus.dtb (Used for Pi 3 model B+)
61 61 RPI3P_DTB_FILE=${RPI3P_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
62 62 RPI3P_UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG:=rpi_3_32b_defconfig}
63 63
64 64 # Debian release
65 65 RELEASE=${RELEASE:=jessie}
66 66 KERNEL_ARCH=${KERNEL_ARCH:=arm}
67 67 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
68 68 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
69 69 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
70 70 if [ "$KERNEL_ARCH" = "arm64" ] ; then
71 71 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
72 72 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
73 73 fi
74 74
75 75 if [ "$RPI_MODEL" = 0 || "$RPI_MODEL" = 1 || "$RPI_MODEL" = 1P ] ; then
76 76 #RASPBERRY PI 1, PI ZERO, PI ZERO W, AND COMPUTE MODULE DEFAULT Kernel BUILD CONFIGURATION
77 77 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
78 78 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
79 79 else
80 80 #RASPBERRY PI 2, PI 3, PI 3+, AND COMPUTE MODULE 3 DEFAULT Kernel BUILD CONFIGURATION
81 81 #https://www.raspberrypi.org/documentation/linux/kernel/building.md
82 82 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
83 83 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
84 84 fi
85 85
86 86 if [ "$RELEASE_ARCH" = "arm64" ] ; then
87 87 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
88 88 else
89 89 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
90 90 fi
91 91 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
92 92
93 93 # URLs
94 94 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
95 95 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
96 96 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
97 97 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
98 98 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
99 99 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
100 100
101 101 # Build directories
102 102 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
103 103 BUILDDIR="${BASEDIR}/build"
104 104
105 105 # Prepare date string for default image file name
106 106 DATE="$(date +%Y-%m-%d)"
107 107 if [ -z "$KERNEL_BRANCH" ] ; then
108 108 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
109 109 else
110 110 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
111 111 fi
112 112
113 113 # Chroot directories
114 114 R="${BUILDDIR}/chroot"
115 115 ETC_DIR="${R}/etc"
116 116 LIB_DIR="${R}/lib"
117 117 BOOT_DIR="${R}/boot/firmware"
118 118 KERNEL_DIR="${R}/usr/src/linux"
119 119 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
120 120
121 121 # Firmware directory: Blank if download from github
122 122 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
123 123
124 124 # General settings
125 125 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
126 126 PASSWORD=${PASSWORD:=raspberry}
127 127 USER_PASSWORD=${USER_PASSWORD:=raspberry}
128 128 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
129 129 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
130 130 EXPANDROOT=${EXPANDROOT:=true}
131 131
132 132 # Keyboard settings
133 133 XKB_MODEL=${XKB_MODEL:=""}
134 134 XKB_LAYOUT=${XKB_LAYOUT:=""}
135 135 XKB_VARIANT=${XKB_VARIANT:=""}
136 136 XKB_OPTIONS=${XKB_OPTIONS:=""}
137 137
138 138 # Network settings (DHCP)
139 139 ENABLE_DHCP=${ENABLE_DHCP:=true}
140 140
141 141 # Network settings (static)
142 142 NET_ADDRESS=${NET_ADDRESS:=""}
143 143 NET_GATEWAY=${NET_GATEWAY:=""}
144 144 NET_DNS_1=${NET_DNS_1:=""}
145 145 NET_DNS_2=${NET_DNS_2:=""}
146 146 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
147 147 NET_NTP_1=${NET_NTP_1:=""}
148 148 NET_NTP_2=${NET_NTP_2:=""}
149 149
150 150 # APT settings
151 151 APT_PROXY=${APT_PROXY:=""}
152 152 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
153 153
154 154 # Feature settings
155 155 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
156 156 ENABLE_I2C=${ENABLE_I2C:=false}
157 157 ENABLE_SPI=${ENABLE_SPI:=false}
158 158 ENABLE_IPV6=${ENABLE_IPV6:=true}
159 159 ENABLE_SSHD=${ENABLE_SSHD:=true}
160 160 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
161 161 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
162 162 ENABLE_SOUND=${ENABLE_SOUND:=true}
163 163 ENABLE_DBUS=${ENABLE_DBUS:=true}
164 164 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
165 165 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
166 166 ENABLE_XORG=${ENABLE_XORG:=false}
167 167 ENABLE_WM=${ENABLE_WM:=""}
168 168 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
169 169 ENABLE_USER=${ENABLE_USER:=true}
170 170 USER_NAME=${USER_NAME:="pi"}
171 171 ENABLE_ROOT=${ENABLE_ROOT:=false}
172 ENABLE_QEMU=${ENABLE_QEMU:=false}
172 173
173 174 # SSH settings
174 175 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
175 176 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
176 177 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
177 178 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
178 179 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
179 180
180 181 # Advanced settings
181 182 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
182 183 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
183 184 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
184 185 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
185 186 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
186 187 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
187 188 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
188 189 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
189 190 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
190 191 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
191 192 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
192 193 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
193 194
194 195 # Kernel compilation settings
195 196 BUILD_KERNEL=${BUILD_KERNEL:=false}
196 197 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
197 198 KERNEL_THREADS=${KERNEL_THREADS:=1}
198 199 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
199 200 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
200 201 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
201 202 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
202 203 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
203 204
204 205 if [ "$KERNEL_ARCH" = "arm64" ] ; then
205 206 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
206 207 else
207 208 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
208 209 fi
209 210
210 211 # Kernel compilation from source directory settings
211 212 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
212 213 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
213 214 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
214 215 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
215 216
216 217 # Reduce disk usage settings
217 218 REDUCE_APT=${REDUCE_APT:=true}
218 219 REDUCE_DOC=${REDUCE_DOC:=true}
219 220 REDUCE_MAN=${REDUCE_MAN:=true}
220 221 REDUCE_VIM=${REDUCE_VIM:=false}
221 222 REDUCE_BASH=${REDUCE_BASH:=false}
222 223 REDUCE_HWDB=${REDUCE_HWDB:=true}
223 224 REDUCE_SSHD=${REDUCE_SSHD:=true}
224 225 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
225 226
226 227 # Encrypted filesystem settings
227 228 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
228 229 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
229 230 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
230 231 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
231 232 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
232 233
233 234 # Chroot scripts directory
234 235 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
235 236
236 237 # Packages required in the chroot build environment
237 238 APT_INCLUDES=${APT_INCLUDES:=""}
238 239 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
239 240
240 241 # Packages required for bootstrapping
241 242 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
242 243 MISSING_PACKAGES=""
243 244
244 245 # Packages installed for c/c++ build environment in chroot (keep empty)
245 246 COMPILER_PACKAGES=""
246 247
247 248 set +x
248 249
249 250 # Set Raspberry Pi model specific configuration
250 251 if [ "$RPI_MODEL" = 0 ] ; then
251 252 DTB_FILE=${RPI2_DTB_FILE}
252 253 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
253 254 elif [ "$RPI_MODEL" = 1 ] ; then
254 255 DTB_FILE=${RPI2_DTB_FILE}
255 256 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
256 257 elif [ "$RPI_MODEL" = 1P ] ; then
257 258 DTB_FILE=${RPI2_DTB_FILE}
258 259 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
259 260 elif [ "$RPI_MODEL" = 2 ] ; then
260 261 DTB_FILE=${RPI2_DTB_FILE}
261 262 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
262 263 elif [ "$RPI_MODEL" = 3 ] ; then
263 264 DTB_FILE=${RPI3_DTB_FILE}
264 265 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
265 266 BUILD_KERNEL=true
266 267 elif [ "$RPI_MODEL" = 3P ] ; then
267 268 DTB_FILE=${RPI3P_DTB_FILE}
268 269 UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG}
269 270 BUILD_KERNEL=true
270 271 else
271 272 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
272 273 exit 1
273 274 fi
274 275
275 276 # Check if the internal wireless interface is supported by the RPi model
276 277 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" = 2 ]; then
277 278 echo "error: The selected Raspberry Pi model has no internal wireless interface"
278 279 exit 1
279 280 fi
280 281
281 282 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
282 283 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
283 284 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
284 285 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
285 286 exit 1
286 287 fi
287 288 fi
288 289
289 290 # Build RPi2/3 Linux kernel if required by Debian release
290 291 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
291 292 BUILD_KERNEL=true
292 293 fi
293 294
294 295 # Add packages required for kernel cross compilation
295 296 if [ "$BUILD_KERNEL" = true ] ; then
296 297 if [ "$KERNEL_ARCH" = "arm" ] ; then
297 298 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
298 299 else
299 300 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
300 301 fi
301 302 fi
302 303
303 304 # Add libncurses5 to enable kernel menuconfig
304 305 if [ "$KERNEL_MENUCONFIG" = true ] ; then
305 306 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
306 307 fi
307 308
308 309 # Add ccache compiler cache for (faster) kernel cross (re)compilation
309 310 if [ "$KERNEL_CCACHE" = true ] ; then
310 311 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
311 312 fi
312 313
313 314 # Add cryptsetup package to enable filesystem encryption
314 315 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
315 316 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
316 APT_INCLUDES="${APT_INCLUDES},cryptsetup,console-setup"
317 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
317 318
318 319 if [ -z "$CRYPTFS_PASSWORD" ] ; then
319 320 echo "error: no password defined (CRYPTFS_PASSWORD)!"
320 321 exit 1
321 322 fi
322 323 ENABLE_INITRAMFS=true
323 324 fi
324 325
325 326 # Add initramfs generation tools
326 327 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
327 328 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
328 329 fi
329 330
330 331 # Add device-tree-compiler required for building the U-Boot bootloader
331 332 if [ "$ENABLE_UBOOT" = true ] ; then
332 333 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
333 334 fi
334 335
335 336 # Check if root SSH (v2) public key file exists
336 337 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
337 338 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
338 339 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
339 340 exit 1
340 341 fi
341 342 fi
342 343
343 344 # Check if $USER_NAME SSH (v2) public key file exists
344 345 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
345 346 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
346 347 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
347 348 exit 1
348 349 fi
349 350 fi
350 351
351 352 # Check if all required packages are installed on the build system
352 353 for package in $REQUIRED_PACKAGES ; do
353 354 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
354 355 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
355 356 fi
356 357 done
357 358
358 359 # If there are missing packages ask confirmation for install, or exit
359 360 if [ -n "$MISSING_PACKAGES" ] ; then
360 361 echo "the following packages needed by this script are not installed:"
361 362 echo "$MISSING_PACKAGES"
362 363
363 364 echo -n "\ndo you want to install the missing packages right now? [y/n] "
364 365 read confirm
365 366 [ "$confirm" != "y" ] && exit 1
366 367
367 368 # Make sure all missing required packages are installed
368 369 apt-get -qq -y install ${MISSING_PACKAGES}
369 370 fi
370 371
371 372 # Check if ./bootstrap.d directory exists
372 373 if [ ! -d "./bootstrap.d/" ] ; then
373 374 echo "error: './bootstrap.d' required directory not found!"
374 375 exit 1
375 376 fi
376 377
377 378 # Check if ./files directory exists
378 379 if [ ! -d "./files/" ] ; then
379 380 echo "error: './files' required directory not found!"
380 381 exit 1
381 382 fi
382 383
383 384 # Check if specified KERNELSRC_DIR directory exists
384 385 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
385 386 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
386 387 exit 1
387 388 fi
388 389
389 390 # Check if specified UBOOTSRC_DIR directory exists
390 391 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
391 392 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
392 393 exit 1
393 394 fi
394 395
395 396 # Check if specified FBTURBOSRC_DIR directory exists
396 397 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
397 398 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
398 399 exit 1
399 400 fi
400 401
401 402 # Check if specified CHROOT_SCRIPTS directory exists
402 403 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
403 404 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
404 405 exit 1
405 406 fi
406 407
407 408 # Check if specified device mapping already exists (will be used by cryptsetup)
408 409 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
409 410 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
410 411 exit 1
411 412 fi
412 413
413 414 # Don't clobber an old build
414 415 if [ -e "$BUILDDIR" ] ; then
415 416 echo "error: directory ${BUILDDIR} already exists, not proceeding"
416 417 exit 1
417 418 fi
418 419
419 420 # Setup chroot directory
420 421 mkdir -p "${R}"
421 422
422 423 # Check if build directory has enough of free disk space >512MB
423 424 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
424 425 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
425 426 exit 1
426 427 fi
427 428
428 429 set -x
429 430
430 431 # Call "cleanup" function on various signals and errors
431 432 trap cleanup 0 1 2 3 6
432 433
433 434 # Add required packages for the minbase installation
434 435 if [ "$ENABLE_MINBASE" = true ] ; then
435 436 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
436 437 fi
437 438
438 439 # Add required locales packages
439 440 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
440 441 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
441 442 fi
442 443
443 444 # Add parted package, required to get partprobe utility
444 445 if [ "$EXPANDROOT" = true ] ; then
445 446 APT_INCLUDES="${APT_INCLUDES},parted"
446 447 fi
447 448
448 449 # Add dbus package, recommended if using systemd
449 450 if [ "$ENABLE_DBUS" = true ] ; then
450 451 APT_INCLUDES="${APT_INCLUDES},dbus"
451 452 fi
452 453
453 454 # Add iptables IPv4/IPv6 package
454 455 if [ "$ENABLE_IPTABLES" = true ] ; then
455 456 APT_INCLUDES="${APT_INCLUDES},iptables"
456 457 fi
457 458
458 459 # Add openssh server package
459 460 if [ "$ENABLE_SSHD" = true ] ; then
460 461 APT_INCLUDES="${APT_INCLUDES},openssh-server"
461 462 fi
462 463
463 464 # Add alsa-utils package
464 465 if [ "$ENABLE_SOUND" = true ] ; then
465 466 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
466 467 fi
467 468
468 469 # Add rng-tools package
469 470 if [ "$ENABLE_HWRANDOM" = true ] ; then
470 471 APT_INCLUDES="${APT_INCLUDES},rng-tools"
471 472 fi
472 473
473 474 # Add fbturbo video driver
474 475 if [ "$ENABLE_FBTURBO" = true ] ; then
475 476 # Enable xorg package dependencies
476 477 ENABLE_XORG=true
477 478 fi
478 479
479 480 # Add user defined window manager package
480 481 if [ -n "$ENABLE_WM" ] ; then
481 482 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
482 483
483 484 # Enable xorg package dependencies
484 485 ENABLE_XORG=true
485 486 fi
486 487
487 488 # Add xorg package
488 489 if [ "$ENABLE_XORG" = true ] ; then
489 490 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
490 491 fi
491 492
492 493 # Replace selected packages with smaller clones
493 494 if [ "$ENABLE_REDUCE" = true ] ; then
494 495 # Add levee package instead of vim-tiny
495 496 if [ "$REDUCE_VIM" = true ] ; then
496 497 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
497 498 fi
498 499
499 500 # Add dropbear package instead of openssh-server
500 501 if [ "$REDUCE_SSHD" = true ] ; then
501 502 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
502 503 fi
503 504 fi
504 505
505 506 if [ "$RELEASE" != "jessie" ] ; then
506 507 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
507 508 fi
508 509
509 510 # Configure kernel sources if no KERNELSRC_DIR
510 511 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
511 512 KERNELSRC_CONFIG=true
512 513 fi
513 514
514 515 # Configure reduced kernel
515 516 if [ "$KERNEL_REDUCE" = true ] ; then
516 517 KERNELSRC_CONFIG=false
517 518 fi
518 519
520 # Configure qemu compatible kernel
521 if [ "$ENABLE_QEMU" = true ] ; then
522 KERNEL_DEFCONFIG="vexpress_defconfig"
523 KERNEL_OLDDEFCONFIG=true
524 fi
525
519 526 # Execute bootstrap scripts
520 527 for SCRIPT in bootstrap.d/*.sh; do
521 528 head -n 3 "$SCRIPT"
522 529 . "$SCRIPT"
523 530 done
524 531
525 532 ## Execute custom bootstrap scripts
526 533 if [ -d "custom.d" ] ; then
527 534 for SCRIPT in custom.d/*.sh; do
528 535 . "$SCRIPT"
529 536 done
530 537 fi
531 538
532 539 # Execute custom scripts inside the chroot
533 540 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
534 541 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
535 542 chroot_exec /bin/bash -x <<'EOF'
536 543 for SCRIPT in /chroot_scripts/* ; do
537 544 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
538 545 $SCRIPT
539 546 fi
540 547 done
541 548 EOF
542 549 rm -rf "${R}/chroot_scripts"
543 550 fi
544 551
545 552 # Remove c/c++ build environment from the chroot
546 553 chroot_remove_cc
547 554
548 555 # Remove apt-utils
549 556 if [ "$RELEASE" = "jessie" ] ; then
550 557 chroot_exec apt-get purge -qq -y --force-yes apt-utils
551 558 fi
552 559
553 560 # Generate required machine-id
554 561 MACHINE_ID=$(dbus-uuidgen)
555 562 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
556 563 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
557 564
558 565 # APT Cleanup
559 566 chroot_exec apt-get -y clean
560 567 chroot_exec apt-get -y autoclean
561 568 chroot_exec apt-get -y autoremove
562 569
563 570 # Unmount mounted filesystems
564 571 umount -l "${R}/proc"
565 572 umount -l "${R}/sys"
566 573
567 574 # Clean up directories
568 575 rm -rf "${R}/run/*"
569 576 rm -rf "${R}/tmp/*"
570 577
571 578 # Clean up files
572 579 rm -f "${ETC_DIR}/ssh/ssh_host_*"
573 580 rm -f "${ETC_DIR}/dropbear/dropbear_*"
574 581 rm -f "${ETC_DIR}/apt/sources.list.save"
575 582 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
576 583 rm -f "${ETC_DIR}/*-"
577 584 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
578 585 rm -f "${ETC_DIR}/resolv.conf"
579 586 rm -f "${R}/root/.bash_history"
580 587 rm -f "${R}/var/lib/urandom/random-seed"
581 588 rm -f "${R}/initrd.img"
582 589 rm -f "${R}/vmlinuz"
583 590 rm -f "${R}${QEMU_BINARY}"
584 591
592 if [ "$ENABLE_QEMU" = true ] ; then
593 # Setup QEMU directory
594 mkdir "${BASEDIR}/qemu"
595
596 # Copy kernel image to QEMU directory
597 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
598
599 # Copy kernel config to QEMU directory
600 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
601
602 # Copy kernel dtbs to QEMU directory
603 for dtb in "${BOOT_DIR}/"*.dtb ; do
604 if [ -f "${dtb}" ] ; then
605 install_readonly "${dtb}" "${BASEDIR}/qemu/"
606 fi
607 done
608
609 # Copy kernel overlays to QEMU directory
610 if [ -d "${BOOT_DIR}/overlays" ] ; then
611 # Setup overlays dtbs directory
612 mkdir "${BASEDIR}/qemu/overlays"
613
614 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
615 if [ -f "${dtb}" ] ; then
616 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
617 fi
618 done
619 fi
620 fi
621
585 622 # Calculate size of the chroot directory in KB
586 623 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
587 624
588 625 # Calculate the amount of needed 512 Byte sectors
589 626 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
590 627 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
591 628 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
592 629
593 630 # The root partition is EXT4
594 631 # This means more space than the actual used space of the chroot is used.
595 632 # As overhead for journaling and reserved blocks 35% are added.
596 633 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
597 634
598 635 # Calculate required image size in 512 Byte sectors
599 636 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
600 637
601 638 # Prepare image file
602 639 if [ "$ENABLE_SPLITFS" = true ] ; then
603 640 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
604 641 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
605 642 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
606 643 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
607 644
608 645 # Write firmware/boot partition tables
609 646 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
610 647 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
611 648 EOM
612 649
613 650 # Write root partition table
614 651 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
615 652 ${TABLE_SECTORS},${ROOT_SECTORS},83
616 653 EOM
617 654
618 655 # Setup temporary loop devices
619 656 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
620 657 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
621 658 else # ENABLE_SPLITFS=false
622 659 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
623 660 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
624 661
625 662 # Write partition table
626 663 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
627 664 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
628 665 ${ROOT_OFFSET},${ROOT_SECTORS},83
629 666 EOM
630 667
631 668 # Setup temporary loop devices
632 669 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
633 670 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
634 671 fi
635 672
636 673 if [ "$ENABLE_CRYPTFS" = true ] ; then
637 674 # Create dummy ext4 fs
638 675 mkfs.ext4 "$ROOT_LOOP"
639 676
640 677 # Setup password keyfile
641 678 touch .password
642 679 chmod 600 .password
643 680 echo -n ${CRYPTFS_PASSWORD} > .password
644 681
645 682 # Initialize encrypted partition
646 683 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
647 684
648 685 # Open encrypted partition and setup mapping
649 686 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
650 687
651 688 # Secure delete password keyfile
652 689 shred -zu .password
653 690
654 691 # Update temporary loop device
655 692 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
656 693
657 694 # Wipe encrypted partition (encryption cipher is used for randomness)
658 695 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
659 696 fi
660 697
661 698 # Build filesystems
662 699 mkfs.vfat "$FRMW_LOOP"
663 700 mkfs.ext4 "$ROOT_LOOP"
664 701
665 702 # Mount the temporary loop devices
666 703 mkdir -p "$BUILDDIR/mount"
667 704 mount "$ROOT_LOOP" "$BUILDDIR/mount"
668 705
669 706 mkdir -p "$BUILDDIR/mount/boot/firmware"
670 707 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
671 708
672 709 # Copy all files from the chroot to the loop device mount point directory
673 710 rsync -a "${R}/" "$BUILDDIR/mount/"
674 711
675 712 # Unmount all temporary loop devices and mount points
676 713 cleanup
677 714
678 715 # Create block map file(s) of image(s)
679 716 if [ "$ENABLE_SPLITFS" = true ] ; then
680 717 # Create block map files for "bmaptool"
681 718 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
682 719 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
683 720
684 721 # Image was successfully created
685 722 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
686 723 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
687 724 else
688 725 # Create block map file for "bmaptool"
689 726 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
690 727
691 728 # Image was successfully created
692 729 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
730
731 # Create qemu qcow2 image
732 if [ "$ENABLE_QEMU" = true ] ; then
733 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
734 QEMU_SIZE=16G
735
736 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
737 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
738
739 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
740 fi
693 741 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant